<* M2EXTENSIONS+ *>

IMPLEMENTATION MODULE WinCrypt_Mac;
FROM WinDef IMPORT BOOL,ULONG,DWORD;
IMPORT SYSTEM;
FROM WinCrypt IMPORT CERT_UNICODE_SET,CRYPT_SUCCEED,CRYPT_FAILED,
			CERT_UNICODE_RDN_ERR_INDEX_MASK,
			CERT_UNICODE_ATTR_ERR_INDEX_MASK,
		     	CERT_UNICODE_RDN_ERR_INDEX_SHIFT, 
			CERT_UNICODE_VALUE_ERR_INDEX_MASK,
			CERT_UNICODE_ATTR_ERR_INDEX_SHIFT,
			CERT_ALT_NAME_ENTRY_ERR_INDEX_SET,
			CERT_ALT_NAME_VALUE_ERR_INDEX_SET,
			CERT_ALT_NAME_VALUE_ERR_INDEX_MASK,
			CERT_ALT_NAME_ENTRY_ERR_INDEX_SHIFT,
			CERT_ALT_NAME_ENTRY_ERR_INDEX_MASK,
			CRL_DIST_POINT_ERR_CRL_SET,
			CRL_DIST_POINT_ERR_INDEX_SET,
			CRL_DIST_POINT_ERR_CRL_ISSUER_BIT,
			CRL_DIST_POINT_ERR_INDEX_MASK,
			CRL_DIST_POINT_ERR_INDEX_SHIFT,
			CERT_MD5_HASH_PROP_ID,
			CERT_SHA1_HASH_PROP_ID; 

PROCEDURE GET_ALG_CLASS (x : ULONG) : BOOL;
BEGIN (* GET_ALG_CLASS *)
 RETURN (SYSTEM.CAST(BITSET,x) * SYSTEM.CAST(BITSET,7<<13) = BITSET{})
END GET_ALG_CLASS;

PROCEDURE GET_ALG_TYPE(x : ULONG) : BOOL;
BEGIN (* GET_ALG_TYPE *)
 RETURN (SYSTEM.CAST(BITSET,x) * SYSTEM.CAST(BITSET,15<<9) = BITSET{})
END GET_ALG_TYPE;

PROCEDURE GET_ALG_SID(x : ULONG) : BOOL;                
BEGIN (* GET_ALG_SID *)
 RETURN (SYSTEM.CAST(BITSET,x) * SYSTEM.CAST(BITSET, 5<<11) = BITSET{}) 
END GET_ALG_SID;


PROCEDURE RCRYPT_SUCCEEDED(rt : BOOL) : BOOL;
BEGIN
	IF rt = CRYPT_SUCCEED THEN
		RETURN TRUE
	END (* if *)
END RCRYPT_SUCCEEDED;

PROCEDURE RCRYPT_FAILED(rt : BOOL) : BOOL;   
BEGIN
	IF rt = CRYPT_FAILED THEN
		RETURN FALSE
	END (* if *)	
END RCRYPT_FAILED;


PROCEDURE GET_CERT_UNICODE_RDN_ERR_INDEX( X : CERT_UNICODE_SET) : BOOL;
BEGIN 
 RETURN SYSTEM.CAST(BITSET,CERT_UNICODE_RDN_ERR_INDEX_MASK) * SYSTEM.CAST(BITSET,SYSTEM.CAST(INTEGER,X) >> SYSTEM.CAST(INTEGER,CERT_UNICODE_RDN_ERR_INDEX_SHIFT)) = BITSET{};
END GET_CERT_UNICODE_RDN_ERR_INDEX;


PROCEDURE GET_CERT_UNICODE_ATTR_ERR_INDEX(X : CERT_UNICODE_SET) : BOOL;  
BEGIN
 RETURN SYSTEM.CAST(BITSET,CERT_UNICODE_ATTR_ERR_INDEX_MASK) * SYSTEM.CAST(BITSET,SYSTEM.CAST(INTEGER,X) >> SYSTEM.CAST(INTEGER,CERT_UNICODE_ATTR_ERR_INDEX_SHIFT)) = BITSET{};
END GET_CERT_UNICODE_ATTR_ERR_INDEX;


PROCEDURE GET_CERT_UNICODE_VALUE_ERR_INDEX(X : CERT_UNICODE_SET) : BOOL;
BEGIN
 RETURN SYSTEM.CAST(BITSET,CERT_UNICODE_VALUE_ERR_INDEX_MASK) * SYSTEM.CAST(BITSET,SYSTEM.CAST(INTEGER,X)) = BITSET{};
END GET_CERT_UNICODE_VALUE_ERR_INDEX;


PROCEDURE GET_CERT_ALT_NAME_ENTRY_ERR_INDEX (X : CERT_ALT_NAME_ENTRY_ERR_INDEX_SET) : BOOL;  
BEGIN
 RETURN SYSTEM.CAST(BITSET,CERT_ALT_NAME_ENTRY_ERR_INDEX_MASK) * SYSTEM.CAST(BITSET,SYSTEM.CAST(INTEGER,X)>> SYSTEM.CAST(INTEGER,CERT_ALT_NAME_ENTRY_ERR_INDEX_SHIFT)) = BITSET{};
END GET_CERT_ALT_NAME_ENTRY_ERR_INDEX;

PROCEDURE GET_CERT_ALT_NAME_VALUE_ERR_INDEX (X : CERT_ALT_NAME_VALUE_ERR_INDEX_SET) : BOOL; 
BEGIN
 RETURN SYSTEM.CAST(BITSET,CERT_ALT_NAME_VALUE_ERR_INDEX_MASK) * SYSTEM.CAST(BITSET,SYSTEM.CAST(INTEGER,X)) = BITSET{};
END GET_CERT_ALT_NAME_VALUE_ERR_INDEX;


PROCEDURE GET_CRL_DIST_POINT_ERR_INDEX(X : CRL_DIST_POINT_ERR_INDEX_SET) : BOOL;
  (* \ ((X >> CRL_DIST_POINT_ERR_INDEX_SHIFT) & CRL_DIST_POINT_ERR_INDEX_MASK) *)
BEGIN
 RETURN SYSTEM.CAST(BITSET,CRL_DIST_POINT_ERR_INDEX_MASK) * SYSTEM.CAST(BITSET,SYSTEM.CAST(INTEGER,X)>>SYSTEM.CAST(INTEGER,CRL_DIST_POINT_ERR_INDEX_SHIFT)) = BITSET{};
END GET_CRL_DIST_POINT_ERR_INDEX;

PROCEDURE IS_CRL_DIST_POINT_ERR_CRL_ISSUER(X : CRL_DIST_POINT_ERR_CRL_SET) : BOOL;
BEGIN
 RETURN SYSTEM.CAST(BITSET,CRL_DIST_POINT_ERR_CRL_ISSUER_BIT) * SYSTEM.CAST(BITSET,SYSTEM.CAST(INTEGER,X)) # BITSET{};
END IS_CRL_DIST_POINT_ERR_CRL_ISSUER;


PROCEDURE CERT_MAX_ASN_ENCODED_DSS_SIGNATURE_LEN() : INTEGER; 
BEGIN
RETURN 2 + 2*(2 + 20 +1);
END CERT_MAX_ASN_ENCODED_DSS_SIGNATURE_LEN;


PROCEDURE IS_CERT_HASH_PROP_ID(X : DWORD) : BOOL;
BEGIN
 IF(CERT_SHA1_HASH_PROP_ID = X) OR (CERT_MD5_HASH_PROP_ID = X) THEN
	RETURN TRUE
  ELSE
	RETURN FALSE
 END
END IS_CERT_HASH_PROP_ID;

END WinCrypt_Mac.